FROM oven/bun:debian AS build
WORKDIR /app

RUN apt-get update -y && \
  apt-get install -y --no-install-recommends curl ca-certificates gnupg && \
  curl -fsSL https://deb.nodesource.com/setup_20.x | bash - && \
  apt-get install -y --no-install-recommends nodejs && \
  apt-get clean && \
  rm -rf /var/lib/apt/lists/*

ENV NODE_ENV=production

COPY package.json bun.lock ./
RUN bun install --frozen-lockfile

COPY . .
RUN bun run build

FROM nginx:alpine AS production

RUN rm /etc/nginx/conf.d/default.conf
COPY .docker/casino.conf /etc/nginx/templates/nginx.conf.template
COPY .docker/entrypoint.sh /docker-entrypoint.d/40-custom-config-env.sh

COPY --from=build /app/dist/casino /usr/share/nginx/html

EXPOSE 80
CMD ["nginx", "-g", "daemon off;"]
